#!/bin/bash
accumsize=$(($1))
scoredir=test-s${accumsize}
double=$(($accumsize*2))

shopt -s lastpipe  # this somehow makes all commands in one shell which allows "read"ing pipes.


printf "\n\n    Xorshift${double}+ PractRand Score Table\n\nCombination   Word  Byte3  Byte2  Byte1   Bit\n===============================================\n" | tee "${scoredir}/PRscore-s${accumsize}.txt"

# Xorshift - Read one line at a time from the file, picking out the first three fields
while IFS=", " read -n 9 a b c
do
	read line
# Convert to integers
	a=$(($a))
	b=$(($b))
	c=$(($c))
	word="    "
	byte3="    "
	byte2="    "
	byte1="    "
	bit="    "

# Output the score

	if [ -f "${scoredir}/PRscore-xs-s${accumsize}-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xs-s${accumsize}-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v word "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xs-s${accumsize}byte$((${accumsize}-8))-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xs-s${accumsize}byte$((${accumsize}-8))-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte3 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xs-s${accumsize}byte$(((${accumsize}-8)/2))-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xs-s${accumsize}byte$(((${accumsize}-8)/2))-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte2 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xs-s${accumsize}byte1-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xs-s${accumsize}byte1-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte1 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xs-s${accumsize}bit-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xs-s${accumsize}bit-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v bit "%3d${suffix:0:1}" ${value}
	fi
	printf " [%2d %2d %2d]   ${word^^}   ${byte3^^}   ${byte2^^}   ${byte1^^}   ${bit^^}\n" ${a} ${b} ${c} | tee -a "${scoredir}/PRscore-s${accumsize}.txt"

done < "${scoredir}/maxiter-xs-s${accumsize}.out"


printf "\n\n    Xoroshiro${double}+ PractRand Score Table\n\nCombination   Word  Byte3  Byte2  Byte1   Bit\n===============================================\n" | tee -a "${scoredir}/PRscore-s${accumsize}.txt"

# Xoroshiro - Read one line at a time from the file, picking out the first three fields
while IFS=", " read -n 9 a b c
do
	read line
# Convert to integers
	a=$(($a))
	b=$(($b))
	c=$(($c))
	word="    "
	byte3="    "
	byte2="    "
	byte1="    "
	bit="    "

# Output the score
#	scoresize=$(ls -lh "${scoredir}/PRscore-xo-s${accumsize}-a${a}b${b}c${c}.out" | awk -F'[,/ \t]*' '{print $5}')
#	printf "Candidate word size ${accumsize} (Xoroshiro${double}+) [${a} ${b} ${c}] - PractRand score: ${SCOREMAP[${scoresize}]}\n"
	if [ -f "${scoredir}/PRscore-xo-s${accumsize}-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xo-s${accumsize}-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v word "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xo-s${accumsize}byte$((${accumsize}-8))-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xo-s${accumsize}byte$((${accumsize}-8))-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte3 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xo-s${accumsize}byte$(((${accumsize}-8)/2))-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xo-s${accumsize}byte$(((${accumsize}-8)/2))-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte2 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xo-s${accumsize}byte1-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xo-s${accumsize}byte1-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v byte1 "%3d${suffix:0:1}" ${value}
	fi
	if [ -f "${scoredir}/PRscore-xo-s${accumsize}bit-a${a}b${b}c${c}.out" ]; then
		cat "${scoredir}/PRscore-xo-s${accumsize}bit-a${a}b${b}c${c}.out" | grep "length=" | tail -n1 | read first value suffix line
		printf -v bit "%3d${suffix:0:1}" ${value}
	fi
	printf " [%2d %2d %2d]   ${word^^}   ${byte3^^}   ${byte2^^}   ${byte1^^}   ${bit^^}\n" ${a} ${b} ${c} | tee -a "${scoredir}/PRscore-s${accumsize}.txt"

done < "${scoredir}/maxiter-xo-s${accumsize}.out"
